# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2
from tilebox.workflows.workflowsv1 import automation_pb2 as workflows_dot_v1_dot_automation__pb2
from tilebox.workflows.workflowsv1 import core_pb2 as workflows_dot_v1_dot_core__pb2


class AutomationServiceStub(object):
    """AutomationService is a service for managing automations. Currently, we support two types of triggers for automations:
    - Bucket triggers, which triggers tasks when an object is uploaded to a storage bucket that matches a glob pattern
    - Cron triggers, which triggers tasks on a schedule
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.ListStorageLocations = channel.unary_unary(
                '/workflows.v1.AutomationService/ListStorageLocations',
                request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                response_deserializer=workflows_dot_v1_dot_automation__pb2.StorageLocations.FromString,
                _registered_method=True)
        self.GetStorageLocation = channel.unary_unary(
                '/workflows.v1.AutomationService/GetStorageLocation',
                request_serializer=workflows_dot_v1_dot_core__pb2.UUID.SerializeToString,
                response_deserializer=workflows_dot_v1_dot_automation__pb2.StorageLocation.FromString,
                _registered_method=True)
        self.CreateStorageLocation = channel.unary_unary(
                '/workflows.v1.AutomationService/CreateStorageLocation',
                request_serializer=workflows_dot_v1_dot_automation__pb2.StorageLocation.SerializeToString,
                response_deserializer=workflows_dot_v1_dot_automation__pb2.StorageLocation.FromString,
                _registered_method=True)
        self.DeleteStorageLocation = channel.unary_unary(
                '/workflows.v1.AutomationService/DeleteStorageLocation',
                request_serializer=workflows_dot_v1_dot_core__pb2.UUID.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)
        self.ListAutomations = channel.unary_unary(
                '/workflows.v1.AutomationService/ListAutomations',
                request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                response_deserializer=workflows_dot_v1_dot_automation__pb2.Automations.FromString,
                _registered_method=True)
        self.GetAutomation = channel.unary_unary(
                '/workflows.v1.AutomationService/GetAutomation',
                request_serializer=workflows_dot_v1_dot_core__pb2.UUID.SerializeToString,
                response_deserializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
                _registered_method=True)
        self.CreateAutomation = channel.unary_unary(
                '/workflows.v1.AutomationService/CreateAutomation',
                request_serializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.SerializeToString,
                response_deserializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
                _registered_method=True)
        self.UpdateAutomation = channel.unary_unary(
                '/workflows.v1.AutomationService/UpdateAutomation',
                request_serializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.SerializeToString,
                response_deserializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
                _registered_method=True)
        self.DeleteAutomation = channel.unary_unary(
                '/workflows.v1.AutomationService/DeleteAutomation',
                request_serializer=workflows_dot_v1_dot_automation__pb2.DeleteAutomationRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)


class AutomationServiceServicer(object):
    """AutomationService is a service for managing automations. Currently, we support two types of triggers for automations:
    - Bucket triggers, which triggers tasks when an object is uploaded to a storage bucket that matches a glob pattern
    - Cron triggers, which triggers tasks on a schedule
    """

    def ListStorageLocations(self, request, context):
        """ListStorageLocations lists all the storage buckets that are available for use as bucket triggers.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetStorageLocation(self, request, context):
        """GetStorageLocation gets a storage location by its ID.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def CreateStorageLocation(self, request, context):
        """CreateStorageLocation creates a new storage bucket.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteStorageLocation(self, request, context):
        """DeleteStorageLocation deletes a storage location.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ListAutomations(self, request, context):
        """ListAutomations lists all the automations that are currently registered in a namespace.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetAutomation(self, request, context):
        """GetAutomation gets an automation by its ID.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def CreateAutomation(self, request, context):
        """CreateAutomation creates a new automation in a namespace.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def UpdateAutomation(self, request, context):
        """UpdateAutomation updates an automation in a namespace.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteAutomation(self, request, context):
        """DeleteAutomation deletes an automation from a namespace.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_AutomationServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'ListStorageLocations': grpc.unary_unary_rpc_method_handler(
                    servicer.ListStorageLocations,
                    request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                    response_serializer=workflows_dot_v1_dot_automation__pb2.StorageLocations.SerializeToString,
            ),
            'GetStorageLocation': grpc.unary_unary_rpc_method_handler(
                    servicer.GetStorageLocation,
                    request_deserializer=workflows_dot_v1_dot_core__pb2.UUID.FromString,
                    response_serializer=workflows_dot_v1_dot_automation__pb2.StorageLocation.SerializeToString,
            ),
            'CreateStorageLocation': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateStorageLocation,
                    request_deserializer=workflows_dot_v1_dot_automation__pb2.StorageLocation.FromString,
                    response_serializer=workflows_dot_v1_dot_automation__pb2.StorageLocation.SerializeToString,
            ),
            'DeleteStorageLocation': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteStorageLocation,
                    request_deserializer=workflows_dot_v1_dot_core__pb2.UUID.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'ListAutomations': grpc.unary_unary_rpc_method_handler(
                    servicer.ListAutomations,
                    request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                    response_serializer=workflows_dot_v1_dot_automation__pb2.Automations.SerializeToString,
            ),
            'GetAutomation': grpc.unary_unary_rpc_method_handler(
                    servicer.GetAutomation,
                    request_deserializer=workflows_dot_v1_dot_core__pb2.UUID.FromString,
                    response_serializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.SerializeToString,
            ),
            'CreateAutomation': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateAutomation,
                    request_deserializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
                    response_serializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.SerializeToString,
            ),
            'UpdateAutomation': grpc.unary_unary_rpc_method_handler(
                    servicer.UpdateAutomation,
                    request_deserializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
                    response_serializer=workflows_dot_v1_dot_automation__pb2.AutomationPrototype.SerializeToString,
            ),
            'DeleteAutomation': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteAutomation,
                    request_deserializer=workflows_dot_v1_dot_automation__pb2.DeleteAutomationRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'workflows.v1.AutomationService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('workflows.v1.AutomationService', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class AutomationService(object):
    """AutomationService is a service for managing automations. Currently, we support two types of triggers for automations:
    - Bucket triggers, which triggers tasks when an object is uploaded to a storage bucket that matches a glob pattern
    - Cron triggers, which triggers tasks on a schedule
    """

    @staticmethod
    def ListStorageLocations(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/ListStorageLocations',
            google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            workflows_dot_v1_dot_automation__pb2.StorageLocations.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def GetStorageLocation(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/GetStorageLocation',
            workflows_dot_v1_dot_core__pb2.UUID.SerializeToString,
            workflows_dot_v1_dot_automation__pb2.StorageLocation.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def CreateStorageLocation(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/CreateStorageLocation',
            workflows_dot_v1_dot_automation__pb2.StorageLocation.SerializeToString,
            workflows_dot_v1_dot_automation__pb2.StorageLocation.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DeleteStorageLocation(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/DeleteStorageLocation',
            workflows_dot_v1_dot_core__pb2.UUID.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def ListAutomations(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/ListAutomations',
            google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            workflows_dot_v1_dot_automation__pb2.Automations.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def GetAutomation(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/GetAutomation',
            workflows_dot_v1_dot_core__pb2.UUID.SerializeToString,
            workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def CreateAutomation(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/CreateAutomation',
            workflows_dot_v1_dot_automation__pb2.AutomationPrototype.SerializeToString,
            workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def UpdateAutomation(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/UpdateAutomation',
            workflows_dot_v1_dot_automation__pb2.AutomationPrototype.SerializeToString,
            workflows_dot_v1_dot_automation__pb2.AutomationPrototype.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DeleteAutomation(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/workflows.v1.AutomationService/DeleteAutomation',
            workflows_dot_v1_dot_automation__pb2.DeleteAutomationRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
